#include <iostream>
#include <vector>
#include <map>

using namespace std;

// Funkcja pomocnicza do zliczania sumy cyfr liczby.
int suma_cyfr(long long liczba) {
  int wynik = 0;
  while (liczba != 0) {
    wynik += liczba % 10;
    liczba /= 10;
  }
  return wynik;
}

int main() {
  long long N, X;
  cin >> N >> X;
  // Ustawiamy obecny element na X.
  // Wstawiamy dodatkowo element zerowy (aby indeksy się zgadzały).
  vector <long long> A = {0, X};
  // Dodatkowo będziemy utrzymywali słownik indeks, który dla każdego
  // elementu ciągu będzie wskazywał jego pierwsze wystąpienie.
  map <long long, int> indeks = {{X, 1}};
  for (int i=2; i<=N; i++) {
    // Każdy kolejny element jest dwukrotnością sumy cyfr poprzedniego.
    A.push_back(2*suma_cyfr(A[i-1]));
    // Jeżeli ostatni element ma już wartość w indeks, to znaleźliśmy cykl.
    if (indeks.find(A[i]) != indeks.end()) {
      // Ustaw początek i koniec ciągu.
      int start_cyklu = indeks[A[i]];
      int koniec_cyklu = i;
      // Liczymy długość cyklu.
      int dlugosc_cyklu = koniec_cyklu - start_cyklu;
      // Znajdujemy odpowiednią pozycję N-tego elementu w cyklu.
      int indeks_na_cyklu = (N - start_cyklu) % dlugosc_cyklu;
      // I wypisujemy odpowiedni element z cyklu.
      cout << A[start_cyklu + indeks_na_cyklu] << "\n";
      return 0;
    }
    // Ustawiamy indeks aktualnego elementu na i.
    indeks[A[i]] = i;
  }
  // Jeżeli nie doszliśmy do ciągu, po prostu wypisz wynik.
  cout << A[N] << "\n";
}
